/*
 * Copyright (C) 2006 Tildeslash Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 *
 * There are special exceptions to the terms and conditions of the GPL 
 * as it is applied to this software. View the full text of the exception
 * in the file EXCEPTIONS accompanying this software distribution.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */


#ifndef PREPAREDSTATEMENTSTRATEGY_H
#define PREPAREDSTATEMENTSTRATEGY_H


/**
 * This interface defines the <b>contract</b> for the concrete database 
 * implementation used for delegation in the PreparedStatement class.
 *
 * @version \$Id: PreparedStatementStrategy.h,v 1.8 2006/01/17 20:17:24 hauk Exp $
 * @file
 */ 

#define T IPreparedStatement_T
typedef struct T *T;

typedef struct prepop {
	char *name;
        void (*free)(T *P);
        int (*setString)(T P, int parameterIndex, const char *x);
        int (*setInt)(T P, int parameterIndex, int x);
        int (*setLLong)(T P, int parameterIndex, long long int x);
        int (*setDouble)(T P, int parameterIndex, double x);
        int (*setBlob)(T P, int parameterIndex, const void *x, int size);
        int (*execute)(T P);
        ResultSet_T (*executeQuery)(T P);
} *Pop_T;

#undef T
#endif
