/*
 * Copyright (C) 2006 Tildeslash Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 *
 * There are special exceptions to the terms and conditions of the GPL 
 * as it is applied to this software. View the full text of the exception
 * in the file EXCEPTIONS accompanying this software distribution.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */


#ifndef RESULTSETSTRATEGY_H
#define RESULTSETSTRATEGY_H


/**
 * This interface defines the <b>contract</b> for the concrete database 
 * implementation used for delegation in the ResultSet class.
 *
 * @version \$Id: ResultSetStrategy.h,v 1.13 2006/06/06 23:45:08 hauk Exp $
 * @file
 */ 

#define T IResultSet_T
typedef struct T *T;

typedef struct rsetop {
        char *name;
        void (*free)(T *R);
        int (*getColumnCount)(T R);
        const char *(*getColumnName)(T R, int column);
        int (*next)(T R);
        long (*getColumnSize)(T R, int columnIndex);
        const char *(*getString)(T R, int columnIndex);
        const char *(*getStringByName)(T R, const char *columnName);
        int (*getInt)(T R, int columnIndex);
        int (*getIntByName)(T R, const char *columnName);
        long long int (*getLLong)(T R, int columnIndex);
        long long int (*getLLongByName)(T R, const char *columnName);
        double (*getDouble)(T R, int columnIndex);
        double (*getDoubleByName)(T R, const char *columnName);
        const void *(*getBlob)(T R, int columnIndex, int *size);
        const void *(*getBlobByName)(T R, const char *columnName, int *size);
        int (*readData)(T R, int columnIndex, void *b, int length, long off);
} *Rop_T;

#undef T
#endif
