/*
 * Copyright (C) 2006 Tildeslash Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 *
 * There are special exceptions to the terms and conditions of the GPL 
 * as it is applied to this software. View the full text of the exception
 * in the file EXCEPTIONS accompanying this software distribution.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */
#ifndef POSTGRESQLPREPAREDSTATEMENT_H
#define POSTGRESQLPREPAREDSTATEMENT_H
#define T IPreparedStatement_T
T PostgresqlPreparedStatement_new(PGconn *db, int maxRows, char *stmt, int prm);
void PostgresqlPreparedStatement_free(T *P);
int PostgresqlPreparedStatement_setString(T P, int parameterIndex, const char *x);
int PostgresqlPreparedStatement_setInt(T P, int parameterIndex, int x);
int PostgresqlPreparedStatement_setLLong(T P, int parameterIndex, long long int x);
int PostgresqlPreparedStatement_setDouble(T P, int parameterIndex, double x);
int PostgresqlPreparedStatement_setBlob(T P, int parameterIndex, const void *x, int size);
int PostgresqlPreparedStatement_execute(T P);
ResultSet_T PostgresqlPreparedStatement_executeQuery(T P);
#undef T
#endif
