/* Generated by re2c 0.9.8 on Sat Nov  4 22:57:25 2006 */
#line 1 "src/net/URL.re"
/*
 * Copyright (C) 2006 Tildeslash Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 *
 * There are special exceptions to the terms and conditions of the GPL 
 * as it is applied to this software. View the full text of the exception
 * in the file EXCEPTIONS accompanying this software distribution.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */


#include "Config.h"

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>

#include "Util.h"
#include "URL.h"


/**
 * Implementation of the URL interface. URL_create() does not 
 * handle wide character code but URL_new() does. The scanner 
 * handle ISO Latin 1 or UTF-8 encoded url's transparently.
 *
 * @version \$Id: URL.re,v 1.19 2006/10/22 16:21:45 hauk Exp $
 * @file
 */


/* ----------------------------------------------------------- Definitions */

typedef struct params {
        char *name;
        char *value;
        struct params *next;
} *param_t;

#define T URL_T
struct T {
	int port;
       	char *ref;
	char *path;
	char *host;
	char *user;
        char *qptr;
	char *query;
	char *portStr;
	char *protocol;
	char *password;
	char *toString;
        param_t params;
        char **paramNames;
	uchar_T *data;
	uchar_T *buffer;
	uchar_T *marker, *limit, *token;
        /* Keep the above align with zild URL_T */
};

/* Unsafe URL characters: [00-1F, 7F-FF] <>\"#%{}|\\^[] ` */
static const uchar_T urlunsafe[256]= {
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
};

#define BUFFER_SIZE 8192
#define UNKNOWN_PORT -1
#define MYSQL_DEFAULT_PORT 3306
#define POSTGRESQL_DEFAULT_PORT 5432
#define YYCTYPE       uchar_T
#define YYCURSOR      U->buffer  
#define YYLIMIT       U->limit  
#define YYMARKER      U->marker
#define YYFILL(n)     
#define SET_PROTOCOL(PORT) *(YYCURSOR-3)=0; \
	U->protocol=U->token;U->port=PORT;goto parse
#define STRDUP(s) (s?Util_strdup(s):NULL)
#define STRNDUP(s, n) (s?Util_strndup(s, n):NULL)
	

/* ------------------------------------------------------------ Prototypes */


static int x2b(char *x);
static int parseURL(T U);
static void setParams(T U);
static char *b2x(int b, char *x);
static void freeParams(param_t *p);


/* ----------------------------------------------------- Protected methods */

#ifdef ZILD_PACKAGE_PROTECTED
#pragma GCC visibility push(hidden)
#endif

T URL_new(const char *url) {
	T U;
	if(! (url && *url))
		return NULL;
	NEW(U);
	U->data= (uchar_T*)Util_strdup(url);
	YYCURSOR= U->data;
	U->port= UNKNOWN_PORT;
	YYLIMIT= U->data + strlen(U->data);
	if(parseURL(U)) {
                if(U->query) 
                        setParams(U);
		return U;
        } 
	URL_free(&U);
	return NULL;
}


T URL_create(const char *url, ...) {
	int r;
	va_list ap;
	uchar_T buf[BUFFER_SIZE];
	if(! (url && *url))
		return NULL;
	va_start(ap, url);
	r= vsnprintf(buf, BUFFER_SIZE, url, ap);
	va_end(ap);
	if(r<0) 
		return NULL;
	return URL_new(buf);
}


void URL_free(T *U) {
	assert(U && *U);
        if((*U)->params) freeParams(&(*U)->params);
        FREE((*U)->paramNames);
	FREE((*U)->toString);
	FREE((*U)->portStr);
	FREE((*U)->query);
	FREE((*U)->data);
	FREE((*U)->host);
	FREE(*U);
}


/* ------------------------------------------------------------ Properties */


const char *URL_getProtocol(T U) {
	assert(U);
	return U->protocol;
}


const char *URL_getUser(T U) {
	assert(U);
	return U->user;
}


const char *URL_getPassword(T U) {
	assert(U);
	return U->password;
}


const char *URL_getHost(T U) {
	assert(U);
	return U->host;
}


int URL_getPort(T U) {
	assert(U);
	return U->port;
}


const char *URL_getPath(T U) {
	assert(U);
	return U->path;
}


const char *URL_getQueryString(T U) {
	assert(U);
	return U->query;
}


const char **URL_getParameterNames(T U) {
        assert(U);
        if(U->params && U->paramNames==NULL) {
                param_t p;
                int i= 0, len= 0;
                for(p= U->params; p; p= p->next) len++;
                U->paramNames= ALLOC((len + 1) * sizeof(*U->paramNames));
                for(p= U->params; p; p= p->next) {
                        U->paramNames[i++]= p->name;
                }
                U->paramNames[i]= NULL;
        }
	return (const char **)U->paramNames;
}


const char *URL_getParameter(T U, const char *name) {
	assert(U);
        if(U->params && name) {
                param_t p;
                for(p= U->params; p; p= p->next) {
                        if(Util_isByteEqual(p->name, name))
                                return p->value;
                }
        }
        return NULL;
}


const char *URL_toString(T U) {
	assert(U);
	if(U->toString==NULL) {
		U->toString= Util_getString("%s://%s%s%s%s%s%s%s%s%s%s", 
					    U->protocol,
					    U->user?U->user:"",
					    U->password?":":"",
					    U->password?U->password:"",
					    U->user?"@":"",
					    U->host?U->host:"",
					    U->portStr?":":"",
					    U->portStr?U->portStr:"",
					    U->path?U->path:"",
					    U->query?"?":"",
					    U->query?U->query:""); 
	}
	return U->toString;
}


char *URL_unescape(char *url) {
	register int x,y;
	if(! (url && *url)) return url;
	for(x=0,y=0;url[y];++x,++y) {
		if((url[x]= url[y]) == '%') {
			url[x]= x2b(&url[y+1]);
			y+=2;
		}
	}
	url[x] = '\0';
	return url;
}


char *URL_escape(const char *url) {
        char *escaped, *p;
	if(!url)
		return NULL;
	p= escaped= ALLOC(3 * strlen(url) + 1);
	while(*url) {
		if(urlunsafe[(unsigned char)(*url)]) {
			p= b2x(*url, p);
		} else {
			*(p++)= *url;
		}
		url++;
	}
	*p= 0;
	return escaped;
}


char *URL_normalize(char *path) {
        char c;
	int i,j;
	if(!path)
		return NULL;
        for(i=j=0; (c=path[i]); ++i) {
                if(c=='/') {
                        while(path[i+1]=='/') ++i;	
                } else if(c=='.' && j && path[j-1]=='/') {
                        if(path[i+1]=='.' && (path[i+2]=='/' || path[i+2]==0)) {
                                if(j>1)
                                        for(j-=2; path[j]!='/' && j>0; --j);
                                i+=2;
                        } else if(path[i+1]=='/' || path[i+1]==0) {
                                ++i;
                                continue;
                        } else
                                c=':';
                }
                if(!(path[j]=path[i])) break; ++j;
	}
	if(!j) { path[0]='/'; j=1; }
	path[j]=0;
	if(path[0]=='/' && path[1]=='/') {
		for(i=j=0;(c=path[i]); ++i) {
			if(c=='/') {
				while(path[i+1]=='/') ++i;	
			}
			if(!(path[j]=path[i])) break; 
			++j;
		}
		path[j]=0;
	}
	return path;
}

#ifdef ZILD_PACKAGE_PROTECTED
#pragma GCC visibility pop
#endif

/* ------------------------------------------------------- Private methods */


static int parseURL(T U) {
	#line 353 "src/net/URL.re"

proto:
	if(YYCURSOR >= YYLIMIT)
		return FALSE;
	U->token=  YYCURSOR;
	{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0,   0,   0,   0,   0,   0, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0,   0, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 387 "<stdout>"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy0;
	++YYCURSOR;
yy0:
	if((YYLIMIT - YYCURSOR) < 13) YYFILL(13);
	yych = *YYCURSOR;
	if(yych <= '@'){
		if(yych <= 0x0D){
			if(yych <= 0x08)	goto yy9;
			if(yych <= 0x0A)	goto yy2;
			if(yych <= 0x0C)	goto yy9;
			goto yy2;
		} else {
			if(yych <= ' '){
				if(yych <= 0x1F)	goto yy9;
				goto yy2;
			} else {
				if(yych <= '/')	goto yy9;
				if(yych <= '9')	goto yy8;
				goto yy9;
			}
		}
	} else {
		if(yych <= 'l'){
			if(yych <= '`'){
				if(yych <= 'Z')	goto yy8;
				goto yy9;
			} else {
				if(yych == 'f')	goto yy4;
				goto yy8;
			}
		} else {
			if(yych <= 'o'){
				if(yych <= 'm')	goto yy6;
				goto yy8;
			} else {
				if(yych <= 'p')	goto yy7;
				if(yych <= 'z')	goto yy8;
				goto yy9;
			}
		}
	}
yy2:	++YYCURSOR;
	goto yy3;
yy3:
#line 360 "src/net/URL.re"
{
                        goto proto;
		   }
#line 439 "<stdout>"
yy4:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Z'){
		if(yych <= '/')	goto yy5;
		if(yych <= ':')	goto yy13;
		if(yych >= 'A')	goto yy13;
		goto yy5;
	} else {
		if(yych <= 'h'){
			if(yych >= 'a')	goto yy13;
			goto yy5;
		} else {
			if(yych <= 'i')	goto yy38;
			if(yych <= 'z')	goto yy13;
			goto yy5;
		}
	}
yy5:
#line 380 "src/net/URL.re"
{
                      	goto proto;
                   }
#line 462 "<stdout>"
yy6:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Z'){
		if(yych <= '/')	goto yy5;
		if(yych <= ':')	goto yy13;
		if(yych <= '@')	goto yy5;
		goto yy13;
	} else {
		if(yych <= 'x'){
			if(yych <= '`')	goto yy5;
			goto yy13;
		} else {
			if(yych <= 'y')	goto yy30;
			if(yych <= 'z')	goto yy13;
			goto yy5;
		}
	}
yy7:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Z'){
		if(yych <= '/')	goto yy5;
		if(yych <= ':')	goto yy13;
		if(yych <= '@')	goto yy5;
		goto yy13;
	} else {
		if(yych <= 'n'){
			if(yych <= '`')	goto yy5;
			goto yy13;
		} else {
			if(yych <= 'o')	goto yy17;
			if(yych <= 'z')	goto yy13;
			goto yy5;
		}
	}
yy8:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= '/')	goto yy5;
		if(yych <= ':')	goto yy13;
		goto yy5;
	} else {
		if(yych <= 'Z')	goto yy13;
		if(yych <= '`')	goto yy5;
		if(yych <= 'z')	goto yy13;
		goto yy5;
	}
yy9:	yych = *++YYCURSOR;
	goto yy5;
yy10:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy14;
	goto yy11;
yy11:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy5;
	}
yy12:	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	goto yy13;
yy13:	if(yybm[0+yych] & 128) {
		goto yy12;
	}
	if(yych == ':')	goto yy10;
	goto yy11;
yy14:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy11;
	goto yy15;
yy15:	++YYCURSOR;
	goto yy16;
yy16:
#line 376 "src/net/URL.re"
{
                      	SET_PROTOCOL(UNKNOWN_PORT);
                   }
#line 537 "<stdout>"
yy17:	yych = *++YYCURSOR;
	if(yych != 's')	goto yy13;
	goto yy18;
yy18:	yych = *++YYCURSOR;
	if(yych != 't')	goto yy13;
	goto yy19;
yy19:	yych = *++YYCURSOR;
	if(yych != 'g')	goto yy13;
	goto yy20;
yy20:	yych = *++YYCURSOR;
	if(yych != 'r')	goto yy13;
	goto yy21;
yy21:	yych = *++YYCURSOR;
	if(yych != 'e')	goto yy13;
	goto yy22;
yy22:	yych = *++YYCURSOR;
	if(yych != 's')	goto yy13;
	goto yy23;
yy23:	yych = *++YYCURSOR;
	if(yych != 'q')	goto yy13;
	goto yy24;
yy24:	yych = *++YYCURSOR;
	if(yych != 'l')	goto yy13;
	goto yy25;
yy25:	yych = *++YYCURSOR;
	if(yych != ':')	goto yy13;
	goto yy26;
yy26:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy11;
	goto yy27;
yy27:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy11;
	goto yy28;
yy28:	++YYCURSOR;
	goto yy29;
yy29:
#line 372 "src/net/URL.re"
{
                      	SET_PROTOCOL(POSTGRESQL_DEFAULT_PORT);
                   }
#line 578 "<stdout>"
yy30:	yych = *++YYCURSOR;
	if(yych != 's')	goto yy13;
	goto yy31;
yy31:	yych = *++YYCURSOR;
	if(yych != 'q')	goto yy13;
	goto yy32;
yy32:	yych = *++YYCURSOR;
	if(yych != 'l')	goto yy13;
	goto yy33;
yy33:	yych = *++YYCURSOR;
	if(yych != ':')	goto yy13;
	goto yy34;
yy34:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy11;
	goto yy35;
yy35:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy11;
	goto yy36;
yy36:	++YYCURSOR;
	goto yy37;
yy37:
#line 368 "src/net/URL.re"
{
                      	SET_PROTOCOL(MYSQL_DEFAULT_PORT);
                   }
#line 604 "<stdout>"
yy38:	yych = *++YYCURSOR;
	if(yych != 'l')	goto yy13;
	goto yy39;
yy39:	yych = *++YYCURSOR;
	if(yych != 'e')	goto yy13;
	goto yy40;
yy40:	yych = *++YYCURSOR;
	if(yych != ':')	goto yy13;
	goto yy41;
yy41:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy11;
	goto yy42;
yy42:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy11;
	goto yy43;
yy43:	++YYCURSOR;
	goto yy44;
yy44:
#line 364 "src/net/URL.re"
{
			SET_PROTOCOL(UNKNOWN_PORT);
                   }
#line 627 "<stdout>"
}
}
#line 383 "src/net/URL.re"

parse:
	if(YYCURSOR >= YYLIMIT)
		return TRUE;
	U->token=  YYCURSOR;
	{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	112, 112, 112,  16, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 240, 112, 112, 
	248, 248, 248, 248, 248, 248, 248, 248, 
	248, 248, 112,  16, 112, 112, 112,  16, 
	 64, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 112, 112, 112, 112, 112, 
	112, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	};

#line 672 "<stdout>"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy45;
	++YYCURSOR;
yy45:
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if(yych <= '.'){
		if(yych <= 0x0D){
			if(yych <= 0x08)	goto yy57;
			if(yych <= 0x0A)	goto yy47;
			if(yych <= 0x0C)	goto yy57;
			goto yy47;
		} else {
			if(yych <= ' '){
				if(yych <= 0x1F)	goto yy57;
				goto yy49;
			} else {
				if(yych == '-')	goto yy52;
				goto yy50;
			}
		}
	} else {
		if(yych <= '?'){
			if(yych <= '/')	goto yy54;
			if(yych <= '9')	goto yy52;
			if(yych <= ':')	goto yy56;
			goto yy50;
		} else {
			if(yych <= 'Z'){
				if(yych <= '@')	goto yy57;
				goto yy52;
			} else {
				if(yych <= '`')	goto yy50;
				if(yych <= 'z')	goto yy52;
				goto yy50;
			}
		}
	}
yy47:	++YYCURSOR;
	goto yy48;
yy48:
#line 390 "src/net/URL.re"
{ 
                        goto parse; 
                   }
#line 720 "<stdout>"
yy49:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 0x1F)	goto yy48;
	goto yy64;
yy50:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych >= ' ')	goto yy64;
	goto yy51;
yy51:
#line 434 "src/net/URL.re"
{
                      	return TRUE;
                   }
#line 734 "<stdout>"
yy52:	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 128) {
		goto yy75;
	}
	if(yych <= 0x1F)	goto yy53;
	if(yych == '.')	goto yy74;
	goto yy64;
yy53:
#line 406 "src/net/URL.re"
{
                        U->host= STRNDUP(U->token, (YYCURSOR - U->token));
                        goto parse; 
                   }
#line 749 "<stdout>"
yy54:	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy67;
yy55:
#line 420 "src/net/URL.re"
{
                        *YYCURSOR= 0;
                        U->path= U->token;
                        URL_normalize(U->path);
                        return TRUE;
                   }
#line 761 "<stdout>"
yy56:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 8) {
		goto yy58;
	}
	if(yych <= 0x1F)	goto yy51;
	goto yy64;
yy57:	yych = *++YYCURSOR;
	goto yy51;
yy58:	yyaccept = 4;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy59;
yy59:	if(yybm[0+yych] & 8) {
		goto yy58;
	}
	if(yych <= 0x1F)	goto yy60;
	if(yych == '@')	goto yy61;
	goto yy63;
yy60:
#line 411 "src/net/URL.re"
{
                        int e= FALSE;
                        U->portStr= STRNDUP(U->token+1, (YYCURSOR-U->token-1));
                        U->port= Util_parseInt(U->portStr, &e);
                        if(e)
                                U->port= UNKNOWN_PORT;
                        goto parse; 
                   }
#line 792 "<stdout>"
yy61:	++YYCURSOR;
	goto yy62;
yy62:
#line 394 "src/net/URL.re"
{
                        char *p;
                        *(YYCURSOR-1)= 0;
                        U->user= U->token;
                        p= strchr(U->user, ':');
                        if(p) {
                                *(p++)= 0;
                                U->password= p;
                        }
                        goto parse; 
                   }
#line 808 "<stdout>"
yy63:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy64;
yy64:	if(yybm[0+yych] & 16) {
		goto yy63;
	}
	if(yych >= '@')	goto yy61;
	goto yy65;
yy65:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy48;
	case 2:	goto yy53;
	case 4:	goto yy60;
	case 3:	goto yy55;
	case 5:	goto yy70;
	case 1:	goto yy51;
	}
yy66:	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	goto yy67;
yy67:	if(yybm[0+yych] & 32) {
		goto yy66;
	}
	if(yych <= '"')	goto yy55;
	if(yych <= '>')	goto yy63;
	if(yych <= '?')	goto yy69;
	goto yy68;
yy68:	yych = *++YYCURSOR;
	if(yych <= '#'){
		if(yych <= 0x1F)	goto yy62;
		if(yych <= '"')	goto yy72;
		goto yy62;
	} else {
		if(yych == ';')	goto yy62;
		goto yy72;
	}
yy69:	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych >= ' ')	goto yy64;
	goto yy70;
yy70:
#line 427 "src/net/URL.re"
{
                        *(YYCURSOR-1)= 0;
                        U->path= U->token;
                        URL_normalize(U->path);
                        goto query; 
                   }
#line 860 "<stdout>"
yy71:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy72;
yy72:	if(yybm[0+yych] & 64) {
		goto yy71;
	}
	if(yych <= '>')	goto yy55;
	goto yy73;
yy73:	yych = *++YYCURSOR;
	goto yy70;
yy74:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '9'){
		if(yych <= ','){
			if(yych <= 0x1F)	goto yy65;
			goto yy63;
		} else {
			if(yych <= '-')	goto yy77;
			if(yych <= '/')	goto yy63;
			goto yy77;
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '?')	goto yy63;
			if(yych <= '@')	goto yy61;
			goto yy77;
		} else {
			if(yych <= '`')	goto yy63;
			if(yych <= 'z')	goto yy77;
			goto yy63;
		}
	}
yy75:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy76;
yy76:	if(yybm[0+yych] & 128) {
		goto yy75;
	}
	if(yych <= '.'){
		if(yych <= 0x1F)	goto yy53;
		if(yych <= '-')	goto yy63;
		goto yy74;
	} else {
		if(yych == '@')	goto yy61;
		goto yy63;
	}
yy77:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy78;
yy78:	if(yych <= '9'){
		if(yych <= '-'){
			if(yych <= 0x1F)	goto yy53;
			if(yych <= ',')	goto yy63;
			goto yy77;
		} else {
			if(yych <= '.')	goto yy74;
			if(yych <= '/')	goto yy63;
			goto yy77;
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '?')	goto yy63;
			if(yych <= '@')	goto yy61;
			goto yy77;
		} else {
			if(yych <= '`')	goto yy63;
			if(yych <= 'z')	goto yy77;
			goto yy63;
		}
	}
}
}
#line 438 "src/net/URL.re"

query:
	if(YYCURSOR >= YYLIMIT)
		return TRUE;
	U->token=  YYCURSOR;
	{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0, 128, 128,   0, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	};

#line 981 "<stdout>"
{
	YYCTYPE yych;
	goto yy79;
	++YYCURSOR;
yy79:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= ' ')	goto yy83;
	if(yych == '#')	goto yy83;
	goto yy82;
yy81:
#line 445 "src/net/URL.re"
{
                        *YYCURSOR= 0;
                        U->qptr= U->token;
                        U->query= STRNDUP(U->token, (YYCURSOR-U->token));
                        goto query;
                   }
#line 1000 "<stdout>"
yy82:	yych = *++YYCURSOR;
	goto yy86;
yy83:	++YYCURSOR;
	goto yy84;
yy84:
#line 452 "src/net/URL.re"
{ 
                      return TRUE;     
                   }
#line 1010 "<stdout>"
yy85:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy86;
yy86:	if(yybm[0+yych] & 128) {
		goto yy85;
	}
	goto yy81;
}
}
#line 456 "src/net/URL.re"

        return FALSE;
}


/*
 * Scan the query string for params. 
 * RFC 2396/3.3 URL path parameters are ignored in this version
 */
static void setParams(T U) {
	uchar_T *l, *s, *t;
        param_t param= NULL;
        s= U->qptr;
	l= s + strlen(s);
#undef YYCTYPE
#undef YYCURSOR
#undef YYLIMIT
#undef YYMARKER
#undef YYFILL
#define YYCTYPE         uchar_T
#define YYCURSOR        s
#define YYLIMIT         l
#define YYMARKER        s
#define YYFILL(n)
start:
        if(YYCURSOR >= YYLIMIT)
                return;
	t= YYCURSOR;
	{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0, 192, 192, 192, 192, 192, 128, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192,  64, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	};

#line 1086 "<stdout>"
{
	YYCTYPE yych;
	goto yy87;
	++YYCURSOR;
yy87:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= ' ')	goto yy93;
	if(yych == '=')	goto yy91;
	goto yy89;
yy89:	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy101;
yy90:
#line 486 "src/net/URL.re"
{
                        /* No parameters, but a querystring */
                        return;
                   }
#line 1106 "<stdout>"
yy91:	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy96;
yy92:
#line 499 "src/net/URL.re"
{
                        *t++= 0;
                        if(*(YYCURSOR-1)=='&')
                                *(YYCURSOR-1)= 0;
                        if(param==NULL) /* format error */
                                return; 
                         param->value= t;
			 goto start;
                   }
#line 1121 "<stdout>"
yy93:	++YYCURSOR;
	goto yy94;
yy94:
#line 509 "src/net/URL.re"
{ 
	                 return;
		   }
#line 1129 "<stdout>"
yy95:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy96;
yy96:	if(yybm[0+yych] & 64) {
		goto yy95;
	}
	if(yych <= '%')	goto yy92;
	goto yy97;
yy97:	yych = *++YYCURSOR;
	goto yy92;
yy98:	++YYCURSOR;
	goto yy99;
yy99:	YYCURSOR -= 1;
#line 491 "src/net/URL.re"
{
                        NEW(param);
                        param->name= t;
                        param->next= U->params;
                        U->params= param;
                        goto start;
                   }
#line 1152 "<stdout>"
yy100:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy101;
yy101:	if(yybm[0+yych] & 128) {
		goto yy100;
	}
	if(yych <= '<')	goto yy90;
	goto yy98;
}
}
#line 512 "src/net/URL.re"

}


static int x2b(char *x) {
	register int b;
	b= ((x[0] >= 'A') ? ((x[0] & 0xdf) - 'A')+10 : (x[0] - '0'));
	b*= 16;
	b+= (x[1] >= 'A' ? ((x[1] & 0xdf) - 'A')+10 : (x[1] - '0'));
	return b;
}


static char *b2x(int b, char *x) {
	static const char b2x_table[] = "0123456789ABCDEF";
	*x++ = '%';
	*x++ = b2x_table[b >> 4];
	*x++ = b2x_table[b & 0xf];
	return x;
}


static void freeParams(param_t *p) {
        if((*p)->next)
                freeParams(&(*p)->next);
        FREE(*p);
}
